//=============================================================================
//
// file :        MenloLFC.h
//
// description : Include for the MenloLFC class.
//
// project :	Low Level RF
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _MenloLFC_H
#define _MenloLFC_H

#include <tango.h>
#include "Menlo.h"
#include <sys/socket.h> /* for socket(), connect(), send(), and recv() */
#include <arpa/inet.h>  /* for sockaddr_in and inet_addr() */

#define PRIORITY_FACTOR	2	//priority multiplier factor

//using namespace Tango;

/**
 * @author	$Author: graziano $
 * @version	$Revision: 1.7 $
 */

 //	Add your own constant definitions here.
 //-----------------------------------------------
class readthread;



namespace MenloLFC_ns
{


/**
 * Class Description:
 * 
 */

/*
 *	Device States Description:
 */


class MenloLFC: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attribute member data.
 */
//@{
		Tango::DevLong	*attr_ISET_read;
		Tango::DevLong	attr_ISET_write;
		Tango::DevLong	*attr_IACT_read;
		Tango::DevLong	*attr_PACT_read;
		Tango::DevLong	*attr_DIODE_TSET_read;
		Tango::DevLong	attr_DIODE_TSET_write;
		Tango::DevLong	*attr_DIODE_TACT_read;
		Tango::DevLong	*attr_MODULE_TACT_read;
		Tango::DevLong	*attr_TCORR_read;
		Tango::DevLong	attr_TCORR_write;
		Tango::DevLong	*attr_TC0_ADJ_ISET_read;
		const Tango::DevLong *	attr_TC0_ADJ_ISET_write;
		Tango::DevLong	*attr_TC0_ADJ_TSET_read;
		const Tango::DevLong *	attr_TC0_ADJ_TSET_write;
		Tango::DevLong	*attr_TC0_ADJ_IACT_read;
		const Tango::DevLong *	attr_TC0_ADJ_IACT_write;
		Tango::DevLong	*attr_TM0_ADJ_TACT_read;
		const Tango::DevLong *	attr_TM0_ADJ_TACT_write;
		Tango::DevLong	*attr_TM0_ADJ_PACT_read;
		const Tango::DevLong *	attr_TM0_ADJ_PACT_write;
		Tango::DevBoolean	*attr_Amplifier_State_read;
		Tango::DevBoolean	attr_Amplifier_State_write;
		Tango::DevLong	*attr_Snapshot_read;
		const Tango::DevLong *	attr_Date_write;
		Tango::DevLong	*attr_Date_read;
		const Tango::DevLong *	attr_Time_write;
		Tango::DevLong	*attr_Time_read;
		Tango::DevDouble	*attr_RTstamp_read;
		Tango::DevDouble	*attr_Tstamp_read;
		Tango::DevDouble	*attr_TstampDiff_read;
		Tango::DevDouble	*attr_TstampStart_read;
		Tango::DevDouble	*attr_Uptime_read;
		Tango::DevLong	*attr_ADJ_PACT_1_read;
		const Tango::DevLong *	attr_ADJ_PACT_1_write;
		Tango::DevDouble	*attr_PACT_1_read;
		Tango::DevDouble	*attr_PMIN_1_read;
		Tango::DevDouble	*attr_PMAX_1_read;
		Tango::DevLong	*attr_Remote__ServiceMode_read;
		Tango::DevBoolean	*attr_EnableAutoSave_read;
		Tango::DevBoolean	attr_EnableAutoSave_write;
//@}

/**
 * @name Device properties
 * Device properties member data.
 */
//@{
/**
 *	Serial device proxy or IP_addr:port of Moxa
 */
	string	serialdevice;
/**
 *	
 */
	Tango::DevLong	serial_timeout;
/**
 *	Sleep time in the polling thread in ms
 */
	Tango::DevDouble	th_sleep;
/**
 *	Sleep time between writing and reading on the serial proxy in ms
 */
	Tango::DevDouble	wr_sleep;
/**
 *	
 */
	Tango::DevLong	dev_add;
//@}

/**
 *	@name Device properties
 *	Device property member data.
 */
//@{
	string deviceSerial;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	MenloLFC(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	MenloLFC(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	MenloLFC(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one destructor is defined for this class */
//@{
/**
 * The object destructor.
 */	
	~MenloLFC() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method before execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name MenloLFC methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for ISET acquisition result.
 */
	virtual void read_ISET(Tango::Attribute &attr);
/**
 *	Write ISET attribute values to hardware.
 */
	virtual void write_ISET(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Amplifier_State acquisition result.
 */
	virtual void read_Amplifier_State(Tango::Attribute &attr);
/**
 *	Write Amplifier_State attribute values to hardware.
 */
	virtual void write_Amplifier_State(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Snapshot acquisition result.
 */
	virtual void read_Snapshot(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Tstamp acquisition result.
 */
	virtual void read_Tstamp(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RTstamp acquisition result.
 */
	virtual void read_RTstamp(Tango::Attribute &attr);
/**
 *	Extract real attribute values for TstampDiff acquisition result.
 */
	virtual void read_TstampDiff(Tango::Attribute &attr);
/**
 *	Extract real attribute values for TstampStart acquisition result.
 */
	virtual void read_TstampStart(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Uptime acquisition result.
 */
	virtual void read_Uptime(Tango::Attribute &attr);
/**
 *	Extract real attribute values for IACT acquisition result.
 */
	virtual void read_IACT(Tango::Attribute &attr);
/**
 *	Extract real attribute values for PACT acquisition result.
 */
	virtual void read_PACT(Tango::Attribute &attr);
/**
 *	Extract real attribute values for DIODE_TSET acquisition result.
 */
	virtual void read_DIODE_TSET(Tango::Attribute &attr);
/**
 *	Write DIODE_TSET attribute values to hardware.
 */
	virtual void write_DIODE_TSET(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for DIODE_TACT acquisition result.
 */
	virtual void read_DIODE_TACT(Tango::Attribute &attr);
/**
 *	Extract real attribute values for MODULE_TACT acquisition result.
 */
	virtual void read_MODULE_TACT(Tango::Attribute &attr);
/**
 *	Extract real attribute values for TCORR acquisition result.
 */
	virtual void read_TCORR(Tango::Attribute &attr);
/**
 *	Write TCORR attribute values to hardware.
 */
	virtual void write_TCORR(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for TC0_ADJ_ISET acquisition result.
 */
	virtual void read_TC0_ADJ_ISET(Tango::Attribute &attr);
/**
 *	Write TC0_ADJ_ISET attribute values to hardware.
 */
	virtual void write_TC0_ADJ_ISET(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for TC0_ADJ_TSET acquisition result.
 */
	virtual void read_TC0_ADJ_TSET(Tango::Attribute &attr);
/**
 *	Write TC0_ADJ_TSET attribute values to hardware.
 */
	virtual void write_TC0_ADJ_TSET(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for TC0_ADJ_IACT acquisition result.
 */
	virtual void read_TC0_ADJ_IACT(Tango::Attribute &attr);
/**
 *	Write TC0_ADJ_IACT attribute values to hardware.
 */
	virtual void write_TC0_ADJ_IACT(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for TM0_ADJ_TACT acquisition result.
 */
	virtual void read_TM0_ADJ_TACT(Tango::Attribute &attr);
/**
 *	Write TM0_ADJ_TACT attribute values to hardware.
 */
	virtual void write_TM0_ADJ_TACT(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for TM0_ADJ_PACT acquisition result.
 */
	virtual void read_TM0_ADJ_PACT(Tango::Attribute &attr);
/**
 *	Write TM0_ADJ_PACT attribute values to hardware.
 */
	virtual void write_TM0_ADJ_PACT(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Date acquisition result.
 */
	virtual void read_Date(Tango::Attribute &attr);
/**
 *	Write Date attribute values to hardware.
 */
	virtual void write_Date(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Time acquisition result.
 */
	virtual void read_Time(Tango::Attribute &attr);
/**
 *	Write Time attribute values to hardware.
 */
	virtual void write_Time(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for ADJ_PACT_1 acquisition result.
 */
	virtual void read_ADJ_PACT_1(Tango::Attribute &attr);
/**
 *	Write ADJ_PACT_1 attribute values to hardware.
 */
	virtual void write_ADJ_PACT_1(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for PACT_1 acquisition result.
 */
	virtual void read_PACT_1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for PMIN_1 acquisition result.
 */
	virtual void read_PMIN_1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for PMAX_1 acquisition result.
 */
	virtual void read_PMAX_1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Remote__ServiceMode acquisition result.
 */
	virtual void read_Remote__ServiceMode(Tango::Attribute &attr);
/**
 *	Extract real attribute values for EnableAutoSave acquisition result.
 */
	virtual void read_EnableAutoSave(Tango::Attribute &attr);
/**
 *	Write EnableAutoSave attribute values to hardware.
 */
	virtual void write_EnableAutoSave(Tango::WAttribute &attr);
/**
 *	Read/Write allowed for ISET attribute.
 */
	virtual bool is_ISET_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Amplifier_State attribute.
 */
	virtual bool is_Amplifier_State_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Tstamp attribute.
 */
	virtual bool is_Tstamp_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RTstamp attribute.
 */
	virtual bool is_RTstamp_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for TstampDiff attribute.
 */
	virtual bool is_TstampDiff_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for TstampStart attribute.
 */
	virtual bool is_TstampStart_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Uptime attribute.
 */
	virtual bool is_Uptime_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for IACT attribute.
 */
	virtual bool is_IACT_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for PACT attribute.
 */
	virtual bool is_PACT_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DIODE_TSET attribute.
 */
	virtual bool is_DIODE_TSET_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DIODE_TACT attribute.
 */
	virtual bool is_DIODE_TACT_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MODULE_TACT attribute.
 */
	virtual bool is_MODULE_TACT_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for TCORR attribute.
 */
	virtual bool is_TCORR_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for TC0_ADJ_ISET attribute.
 */
	virtual bool is_TC0_ADJ_ISET_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for TC0_ADJ_TSET attribute.
 */
	virtual bool is_TC0_ADJ_TSET_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for TC0_ADJ_IACT attribute.
 */
	virtual bool is_TC0_ADJ_IACT_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for TM0_ADJ_TACT attribute.
 */
	virtual bool is_TM0_ADJ_TACT_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for TM0_ADJ_PACT attribute.
 */
	virtual bool is_TM0_ADJ_PACT_allowed(Tango::AttReqType type);
/**
 *	Read allowed for Snapshot attribute.
 */
	virtual bool is_Snapshot_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Date attribute.
 */
	virtual bool is_Date_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Time attribute.
 */
	virtual bool is_Time_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ADJ_PACT_1 attribute.
 */
	virtual bool is_ADJ_PACT_1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for PACT_1 attribute.
 */
	virtual bool is_PACT_1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for PMIN_1 attribute.
 */
	virtual bool is_PMIN_1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for PMAX_1 attribute.
 */
	virtual bool is_PMAX_1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Remote__ServiceMode attribute.
 */
	virtual bool is_Remote__ServiceMode_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for EnableAutoSave attribute.
 */
	virtual bool is_EnableAutoSave_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for DeviceAddress command.
 */
	virtual bool is_DeviceAddress_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for DeviceID command.
 */
	virtual bool is_DeviceID_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for DeviceHWver command.
 */
	virtual bool is_DeviceHWver_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for DeviceFWver command.
 */
	virtual bool is_DeviceFWver_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for DeviceDispFWver command.
 */
	virtual bool is_DisplayFWver_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for DeviceSerial command.
 */
	virtual bool is_DeviceSerial_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for EnterServiceCode command.
 */
	virtual bool is_EnterServiceCode_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for SaveConfig command.
 */
	virtual bool is_SaveConfig_allowed(const CORBA::Any &any);
/**
 * Read Device Address
 *	@return	Device Address
 *	@exception DevFailed
 */
	Tango::DevLong	device_address();
/**
 * Read Device ID
 *	@return	Device ID
 *	@exception DevFailed
 */
	Tango::DevString	device_id();
/**
 * Read Device Hw Ver
 *	@return	Device HW Ver
 *	@exception DevFailed
 */
	Tango::DevString	device_hwver();
/**
 * Read Device Fw Ver
 *	@return	Device FW Ver
 *	@exception DevFailed
 */
	Tango::DevString	device_fwver();
/**
 * Read Display Fw Ver
 *	@return	Display FW Ver
 *	@exception DevFailed
 */
	Tango::DevString	display_fwver();
/**
 * Read Device Serial
 *	@return	Device Serial
 *	@exception DevFailed
 */
	Tango::DevString	device_serial();
/**
 * enter service code
 *	@return
 *	@exception DevFailed
 */
	void	enter_service_code(Tango::DevUShort);
/**
 * Save config
 *	@return
 *	@exception DevFailed
 */
	void	save_config();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	


protected :	
	//	Add your own data members here
	//-----------------------------------------
	void write_serial(char *, long);
	void read_serial(char *, long &);
	void write_socket(char *write_str, long size);
	void read_socket(char *, long &);
	readthread *readloop;
	
	template <typename Attr_type> void apply_attr_value(Tango::Attribute &attr, string reg, Attr_type/*Tango::DevDouble*/ *attr_read, double factor, int index, int subdevice, int size);
	void apply_attr_value_state(Tango::Attribute &attr, string reg, Tango::DevLong *attr_read, int index);
	void apply_attr_value_dacs(Tango::Attribute &attr, string reg, Tango::DevLong *attr_read);
	void apply_attr_value_adcs(Tango::Attribute &attr, string reg, Tango::DevLong *attr_read);
	void apply_attr_value_tstamp(Tango::Attribute &attr, string reg, Tango::DevDouble *attr_read);
	template <typename Attr_type> void write_attr_value(Tango::WAttribute &attr, string reg, Attr_type/*Tango::DevLong*/ attr_write, int subdevice);
	void string_explode(string str, string separator, vector<unsigned int>* results, bool b_hex=false);
	byte dev_add_loc;			//local device address
	char dev_id[256];
	char dev_hw_ver[256];
	char dev_fw_ver[256];
	char display_fw_ver[256];
	char dev_serial[256];
	bool moxa;
	char servIP[INET_ADDRSTRLEN];
	unsigned short servPort;
    int sock;
    struct sockaddr_in servAddr;
	int counter;    
    Menlo *menlo;
    
    void reconnect();
    void dump_msg(string label, int cnt, char *buf);
	int timeoutHiPrio;
	int timeoutLowPrio;	
	
public:
	Tango::DeviceProxy *devserial;
	int abortflag;  // flag used to abort reading loop
	int check_timeout(timeval, double);	
	void abort_sleep(double time);
	omni_mutex *mutex;
	int WriteRead(int cmd, string s_reg, int subdevice, data_t &rdata);
	data_map read_data;
	bool conn_error;
};

}	// namespace_ns

#endif	// _MenloLFC_H
