static const char *ClassId    = "";
static const char *TagName    = "";
static const char *CvsPath    = "";
static const char *SvnPath    = "";
static const char *HttpServer = "";
//+=============================================================================
//
// file :        MenloLFCClass.cpp
//
// description : C++ source for the MenloLFCClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the MenloLFC once per process.
//
// project :     TANGO Device Server
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <MenloLFC.h>
#include <MenloLFCClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create MenloLFCClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_MenloLFC_class(const char *name) {
		return MenloLFC_ns::MenloLFCClass::init(name);
	}
}


namespace MenloLFC_ns
{
//+----------------------------------------------------------------------------
//
// method : 		DeviceSerialCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DeviceSerialCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout << "DeviceSerialCmd::execute(): arrived" << endl;

	return insert((static_cast<MenloLFC *>(device))->device_serial());
}

//+----------------------------------------------------------------------------
//
// method : 		DeviceFWverCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DeviceFWverCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout << "DeviceFWverCmd::execute(): arrived" << endl;

	return insert((static_cast<MenloLFC *>(device))->device_fwver());
}

//+----------------------------------------------------------------------------
//
// method : 		DisplayFWverCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DisplayFWverCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout << "DisplayFWverCmd::execute(): arrived" << endl;

	return insert((static_cast<MenloLFC *>(device))->display_fwver());
}

//+----------------------------------------------------------------------------
//
// method : 		DeviceHWverCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DeviceHWverCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout << "DeviceHWverCmd::execute(): arrived" << endl;

	return insert((static_cast<MenloLFC *>(device))->device_hwver());
}

//+----------------------------------------------------------------------------
//
// method : 		DeviceIDCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DeviceIDCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout << "DeviceIDCmd::execute(): arrived" << endl;

	return insert((static_cast<MenloLFC *>(device))->device_id());
}

//+----------------------------------------------------------------------------
//
// method : 		DeviceAddressCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DeviceAddressCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout << "DeviceAddressCmd::execute(): arrived" << endl;

	return insert((static_cast<MenloLFC *>(device))->device_address());
}

//+----------------------------------------------------------------------------
//
// method : 		EnterServiceCodeClass::execute()
//
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *EnterServiceCodeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout << "EnterServiceCodeClass::execute(): arrived" << endl;
	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<MenloLFC *>(device))->enter_service_code(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SaveConfigClass::execute()
//
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SaveConfigClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout << "SaveConfigClass::execute(): arrived" << endl;

	((static_cast<MenloLFC *>(device))->save_config());
	return new CORBA::Any();
}

//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
MenloLFCClass *MenloLFCClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::MenloLFCClass(string &s)
// 
// description : 	constructor for the MenloLFCClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
MenloLFCClass::MenloLFCClass(string &s):DeviceClass(s)
{

	cout << "Entering MenloLFCClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout << "Leaving MenloLFCClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::~MenloLFCClass()
// 
// description : 	destructor for the MenloLFCClass
//
//-----------------------------------------------------------------------------
MenloLFCClass::~MenloLFCClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
MenloLFCClass *MenloLFCClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new MenloLFCClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

MenloLFCClass *MenloLFCClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void MenloLFCClass::command_factory()
{
	command_list.push_back(new DeviceAddressCmd("DeviceAddress",
		Tango::DEV_VOID, Tango::DEV_LONG,
		"",
		"Device Address",
		Tango::OPERATOR));
	command_list.push_back(new DeviceIDCmd("DeviceID",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"Device ID",
		Tango::OPERATOR));
	command_list.push_back(new DeviceHWverCmd("DeviceHWver",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"Device HW Ver",
		Tango::OPERATOR));
	command_list.push_back(new DeviceFWverCmd("DeviceFWver",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"Device FW Ver",
		Tango::OPERATOR));
	command_list.push_back(new DisplayFWverCmd("DisplayFWver",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"Display FW Ver",
		Tango::OPERATOR));
	command_list.push_back(new DeviceSerialCmd("DeviceSerial",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"Device Serial",
		Tango::OPERATOR));
	command_list.push_back(new EnterServiceCodeClass("EnterServiceCode",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SaveConfigClass("SaveConfig",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum MenloLFCClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum MenloLFCClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum MenloLFCClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void MenloLFCClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	// Erase all the dynamic attributes previously added to the class
	//-------------------------------------------------------------
	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new MenloLFC(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: MenloLFCClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void MenloLFCClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : ISET
	ISETAttrib	*iset = new ISETAttrib();
	Tango::UserDefaultAttrProp	iset_prop;
	iset_prop.set_unit("mA");
	iset_prop.set_standard_unit("1.0");
	iset_prop.set_display_unit("mA");
	iset_prop.set_description("Read/Write iset in mA");
	iset->set_default_properties(iset_prop);
	att_list.push_back(iset);

	//	Attribute : Amplifier_State
	Amplifier_StateAttrib	*amplifier__state = new Amplifier_StateAttrib();
	Tango::UserDefaultAttrProp	amplifier__state_prop;
	amplifier__state_prop.set_description("Switch Amplifier(1=on, 0=off)");
	amplifier__state->set_default_properties(amplifier__state_prop);
	att_list.push_back(amplifier__state);

	//	Attribute : Tstamp
	TstampAttrib	*tstamp = new TstampAttrib();
	Tango::UserDefaultAttrProp	tstamp_prop;
	tstamp_prop.set_unit("s");
	tstamp_prop.set_standard_unit("1.0");
	tstamp_prop.set_display_unit("s");
	tstamp_prop.set_description("Read timestamp (system time)");
	tstamp->set_default_properties(tstamp_prop);
	att_list.push_back(tstamp);

	//	Attribute : RTstamp
	RTstampAttrib	*rtstamp = new RTstampAttrib();
	Tango::UserDefaultAttrProp	rtstamp_prop;
	rtstamp_prop.set_unit("s");
	rtstamp_prop.set_standard_unit("1.0");
	rtstamp_prop.set_display_unit("s");
	rtstamp_prop.set_description("Read timestamp (RTC)");
	rtstamp->set_default_properties(rtstamp_prop);
	att_list.push_back(rtstamp);

	//	Attribute : TstampDiff
	TstampDiffAttrib	*tstamp_diff = new TstampDiffAttrib();
	Tango::UserDefaultAttrProp	tstamp_diff_prop;
	tstamp_diff_prop.set_unit("s");
	tstamp_diff_prop.set_standard_unit("1.0");
	tstamp_diff_prop.set_display_unit("s");
	tstamp_diff_prop.set_description("Difference between RTC and system time");
	tstamp_diff->set_default_properties(tstamp_diff_prop);
	att_list.push_back(tstamp_diff);

	//	Attribute : TstampStart
	TstampStartAttrib	*tstamp_start = new TstampStartAttrib();
	Tango::UserDefaultAttrProp	tstamp_start_prop;
	tstamp_start_prop.set_unit("s");
	tstamp_start_prop.set_standard_unit("1.0");
	tstamp_start_prop.set_display_unit("s");
	tstamp_start_prop.set_description("Starting time (RTC) as a timestamp");
	tstamp_start->set_default_properties(tstamp_start_prop);
	att_list.push_back(tstamp_start);

	//	Attribute : Uptime
	UptimeAttrib	*uptime = new UptimeAttrib();
	Tango::UserDefaultAttrProp	uptime_prop;
	uptime_prop.set_unit("s");
	uptime_prop.set_standard_unit("1.0");
	uptime_prop.set_display_unit("s");
	uptime_prop.set_description("Uptime");
	uptime->set_default_properties(uptime_prop);
	att_list.push_back(uptime);

	//	Attribute : IACT
	IACTAttrib	*iact = new IACTAttrib();
	Tango::UserDefaultAttrProp	iact_prop;
	iact_prop.set_unit("mA");
	iact_prop.set_standard_unit("1.0");
	iact_prop.set_display_unit("mA");
	iact_prop.set_description("Read actual value of diode current in mA");
	iact->set_default_properties(iact_prop);
	att_list.push_back(iact);

	//	Attribute : PACT
	PACTAttrib	*pact = new PACTAttrib();
	Tango::UserDefaultAttrProp	pact_prop;
	pact_prop.set_unit("mW");
	pact_prop.set_standard_unit("1.0");
	pact_prop.set_display_unit("mW");
	pact_prop.set_description("Read actual output power of diode");
	pact->set_default_properties(pact_prop);
	att_list.push_back(pact);

	//	Attribute : DIODE_TSET
	DIODE_TSETAttrib	*diode__tset = new DIODE_TSETAttrib();
	Tango::UserDefaultAttrProp	diode__tset_prop;
	diode__tset_prop.set_unit("uC");
	diode__tset_prop.set_standard_unit("1.0");
	diode__tset_prop.set_display_unit("uC");
	diode__tset_prop.set_description("Read/Write value of diode temperature controller in uC");
	diode__tset->set_default_properties(diode__tset_prop);
	att_list.push_back(diode__tset);

	//	Attribute : DIODE_TACT
	DIODE_TACTAttrib	*diode__tact = new DIODE_TACTAttrib();
	Tango::UserDefaultAttrProp	diode__tact_prop;
	diode__tact_prop.set_unit("uC");
	diode__tact_prop.set_standard_unit("1.0");
	diode__tact_prop.set_display_unit("uC");
	diode__tact_prop.set_description("Read actual diode temperature in uC");
	diode__tact->set_default_properties(diode__tact_prop);
	att_list.push_back(diode__tact);

	//	Attribute : MODULE_TACT
	MODULE_TACTAttrib	*module__tact = new MODULE_TACTAttrib();
	Tango::UserDefaultAttrProp	module__tact_prop;
	module__tact_prop.set_unit("uC");
	module__tact_prop.set_standard_unit("1.0");
	module__tact_prop.set_display_unit("uC");
	module__tact_prop.set_description("Read actual module temperature in uC");
	module__tact->set_default_properties(module__tact_prop);
	att_list.push_back(module__tact);

	//	Attribute : TCORR
	TCORRAttrib	*tcorr = new TCORRAttrib();
	Tango::UserDefaultAttrProp	tcorr_prop;
	tcorr_prop.set_unit("-K/A");
	tcorr_prop.set_standard_unit("1.0");
	tcorr_prop.set_display_unit("-K/A");
	tcorr_prop.set_description("Current dependent temperature shift (-K/A)");
	tcorr->set_default_properties(tcorr_prop);
	att_list.push_back(tcorr);

	//	Attribute : TC0_ADJ_ISET
	TC0_ADJ_ISETAttrib	*tc0__adj__iset = new TC0_ADJ_ISETAttrib();
	Tango::UserDefaultAttrProp	tc0__adj__iset_prop;
	tc0__adj__iset_prop.set_description("iset adjustment and range:\n [0]=raw_0\n [1]=phys_0\n [2]=raw_1\n [3]=phys_1\n [4]=range_min\n [5]=range_max");
	tc0__adj__iset->set_default_properties(tc0__adj__iset_prop);
	att_list.push_back(tc0__adj__iset);

	//	Attribute : TC0_ADJ_TSET
	TC0_ADJ_TSETAttrib	*tc0__adj__tset = new TC0_ADJ_TSETAttrib();
	Tango::UserDefaultAttrProp	tc0__adj__tset_prop;
	tc0__adj__tset_prop.set_description("tset adjustment and range:\n [0]=raw_0\n [1]=phys_0\n [2]=raw_1\n [3]=phys_1\n [4]=range_min\n [5]=range_max");
	tc0__adj__tset->set_default_properties(tc0__adj__tset_prop);
	att_list.push_back(tc0__adj__tset);

	//	Attribute : TC0_ADJ_IACT
	TC0_ADJ_IACTAttrib	*tc0__adj__iact = new TC0_ADJ_IACTAttrib();
	Tango::UserDefaultAttrProp	tc0__adj__iact_prop;
	tc0__adj__iact_prop.set_description("iact adjustment:\n [0]=raw_0\n [1]=phys_0\n [2]=raw_1\n [3]=phys_1");
	tc0__adj__iact->set_default_properties(tc0__adj__iact_prop);
	att_list.push_back(tc0__adj__iact);

	//	Attribute : TM0_ADJ_TACT
	TM0_ADJ_TACTAttrib	*tm0__adj__tact = new TM0_ADJ_TACTAttrib();
	Tango::UserDefaultAttrProp	tm0__adj__tact_prop;
	tm0__adj__tact_prop.set_description("tact adjustment:\n [0]=raw_0\n [1]=phys_0\n [2]=raw_1\n [3]=phys_1");
	tm0__adj__tact->set_default_properties(tm0__adj__tact_prop);
	att_list.push_back(tm0__adj__tact);

	//	Attribute : TM0_ADJ_PACT
	TM0_ADJ_PACTAttrib	*tm0__adj__pact = new TM0_ADJ_PACTAttrib();
	Tango::UserDefaultAttrProp	tm0__adj__pact_prop;
	tm0__adj__pact_prop.set_description("pact adjustment:\n [0]=raw_0\n [1]=phys_0\n [2]=raw_1\n [3]=phys_1");
	tm0__adj__pact->set_default_properties(tm0__adj__pact_prop);
	att_list.push_back(tm0__adj__pact);

	//	Attribute : Date
	DateAttrib	*date = new DateAttrib();
	Tango::UserDefaultAttrProp	date_prop;
	date_prop.set_description("RTC date setting:\n [0]=day of month(1-31)\n [1]=month(1-12)\n [2]=year after 2000(0-99)");
	date->set_default_properties(date_prop);
	att_list.push_back(date);

	//	Attribute : Time
	TimeAttrib	*time = new TimeAttrib();
	Tango::UserDefaultAttrProp	time_prop;
	time_prop.set_description("RTC time setting:\n [0]=hour(0-23)\n [1]=minute(0-59)\n [2]=second(0-59)");
	time->set_default_properties(time_prop);
	att_list.push_back(time);
	
	//	Attribute : ADJ_PACT_1
	ADJ_PACT_1Attrib	*adj__pact__1 = new ADJ_PACT_1Attrib();
	Tango::UserDefaultAttrProp	adj__pact__1_prop;
	adj__pact__1_prop.set_description("pact 1 adjustment:\n [0]=raw_0\n [1]=phys_0\n [2]=raw_1\n [3]=phys_1");
	adj__pact__1->set_default_properties(adj__pact__1_prop);
	att_list.push_back(adj__pact__1);
	
	//	Attribute : PACT_1
	PACT_1Attrib	*pact__1 = new PACT_1Attrib();
	Tango::UserDefaultAttrProp	pact__1_prop;
	pact__1_prop.set_unit("uW");
	pact__1_prop.set_standard_unit("1.0");
	pact__1_prop.set_display_unit("uW");
	pact__1_prop.set_description("Read actual output power of diode 1");
	pact__1->set_default_properties(pact__1_prop);
	att_list.push_back(pact__1);
	
	//	Attribute : PMIN_1
	PMIN_1Attrib	*pmin__1 = new PMIN_1Attrib();
	Tango::UserDefaultAttrProp	pmin__1_prop;
	pmin__1_prop.set_unit("uW");
	pmin__1_prop.set_standard_unit("1.0");
	pmin__1_prop.set_display_unit("uW");
	pmin__1_prop.set_description("Lower limit of power of diode 1");
	pmin__1->set_default_properties(pmin__1_prop);
	att_list.push_back(pmin__1);
	
	//	Attribute : PMAX_1
	PMAX_1Attrib	*pmax__1 = new PMAX_1Attrib();
	Tango::UserDefaultAttrProp	pmax__1_prop;
	pmax__1_prop.set_unit("uW");
	pmax__1_prop.set_standard_unit("1.0");
	pmax__1_prop.set_display_unit("uW");
	pmax__1_prop.set_description("Upper limit of power of diode 1");
	pmax__1->set_default_properties(pmax__1_prop);
	att_list.push_back(pmax__1);

	//	Attribute : Remote__ServiceMode
	Remote__ServiceModeAttrib	*remote__service_mode = new Remote__ServiceModeAttrib();
	Tango::UserDefaultAttrProp	remote__service_mode_prop;
	remote__service_mode_prop.set_description("Service Mode enabled");
	remote__service_mode->set_default_properties(remote__service_mode_prop);
	att_list.push_back(remote__service_mode);

	//	Attribute : EnableAutoSave
	EnableAutoSaveAttrib	*enable_auto_save = new EnableAutoSaveAttrib();
	Tango::UserDefaultAttrProp	enable_auto_save_prop;
	enable_auto_save_prop.set_description("Enable/Disable auto_saves on this device");
	enable_auto_save->set_default_properties(enable_auto_save_prop);
	enable_auto_save->set_memorized();
	enable_auto_save->set_memorized_init(true);
	att_list.push_back(enable_auto_save);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void MenloLFCClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	MenloLFCClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void MenloLFCClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "Serialdevice";
	prop_desc = "Serial device proxy or IP_addr:port of Moxa";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Serial_timeout";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Th_sleep";
	prop_desc = "Sleep time in the polling thread in ms";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Wr_sleep";
	prop_desc = "Sleep time between writing and reading on the serial proxy in ms";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Dev_add";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		MenloLFCClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void MenloLFCClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Low Level RF");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("  ");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs or svn location
	string	filename(classname);
	filename += "Class.cpp";
	
	// Create a string with the class ID to
	// get the string into the binary
	string	class_id(ClassId);
	
	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}
	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
