//=============================================================================
//
// file :         MenloLFCClass.h
//
// description :  Include for the MenloLFCClass root class.
//                This class is the singleton class for
//                the MenloLFC device class.
//                It contains all properties and methods which the 
//                MenloLFC requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _MenloLFCCLASS_H
#define _MenloLFCCLASS_H

#include <tango.h>
#include <MenloLFC.h>


namespace MenloLFC_ns
{//=====================================
//	Define classes for attributes
//=====================================
class EnableAutoSaveAttrib: public Tango::Attr
{
public:
	EnableAutoSaveAttrib():Attr("EnableAutoSave", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnableAutoSaveAttrib() {};

	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_EnableAutoSave(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_EnableAutoSave(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_EnableAutoSave_allowed(ty);}
};

class Remote__ServiceModeAttrib: public Tango::Attr
{
public:
	Remote__ServiceModeAttrib():Attr("Remote__ServiceMode", Tango::DEV_LONG, Tango::READ) {};
	~Remote__ServiceModeAttrib() {};

	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_Remote__ServiceMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_Remote__ServiceMode_allowed(ty);}
};

class PMAX_1Attrib: public Tango::Attr
{
public:
	PMAX_1Attrib():Attr("PMAX_1", Tango::DEV_DOUBLE, Tango::READ) {};
	~PMAX_1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_PMAX_1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_PMAX_1_allowed(ty);}
};

class PMIN_1Attrib: public Tango::Attr
{
public:
	PMIN_1Attrib():Attr("PMIN_1", Tango::DEV_DOUBLE, Tango::READ) {};
	~PMIN_1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_PMIN_1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_PMIN_1_allowed(ty);}
};

class PACT_1Attrib: public Tango::Attr
{
public:
	PACT_1Attrib():Attr("PACT_1", Tango::DEV_DOUBLE, Tango::READ) {};
	~PACT_1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_PACT_1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_PACT_1_allowed(ty);}
};

class ADJ_PACT_1Attrib: public Tango::SpectrumAttr
{
public:
	ADJ_PACT_1Attrib():SpectrumAttr("ADJ_PACT_1", Tango::DEV_LONG, Tango::READ_WRITE, 4) {};
	~ADJ_PACT_1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_ADJ_PACT_1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_ADJ_PACT_1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_ADJ_PACT_1_allowed(ty);}
};

class TimeAttrib: public Tango::SpectrumAttr
{
public:
	TimeAttrib():SpectrumAttr("Time", Tango::DEV_LONG, Tango::READ_WRITE, 3) {};
	~TimeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_Time(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_Time(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_Time_allowed(ty);}
};

class DateAttrib: public Tango::SpectrumAttr
{
public:
	DateAttrib():SpectrumAttr("Date", Tango::DEV_LONG, Tango::READ_WRITE, 3) {};
	~DateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_Date(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_Date(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_Date_allowed(ty);}
};

class TM0_ADJ_PACTAttrib: public Tango::SpectrumAttr
{
public:
	TM0_ADJ_PACTAttrib():SpectrumAttr("TM0_ADJ_PACT", Tango::DEV_LONG, Tango::READ_WRITE, 4) {};
	~TM0_ADJ_PACTAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_TM0_ADJ_PACT(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_TM0_ADJ_PACT(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_TM0_ADJ_PACT_allowed(ty);}
};

class TM0_ADJ_TACTAttrib: public Tango::SpectrumAttr
{
public:
	TM0_ADJ_TACTAttrib():SpectrumAttr("TM0_ADJ_TACT", Tango::DEV_LONG, Tango::READ_WRITE, 4) {};
	~TM0_ADJ_TACTAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_TM0_ADJ_TACT(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_TM0_ADJ_TACT(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_TM0_ADJ_TACT_allowed(ty);}
};

class TC0_ADJ_IACTAttrib: public Tango::SpectrumAttr
{
public:
	TC0_ADJ_IACTAttrib():SpectrumAttr("TC0_ADJ_IACT", Tango::DEV_LONG, Tango::READ_WRITE, 4) {};
	~TC0_ADJ_IACTAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_TC0_ADJ_IACT(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_TC0_ADJ_IACT(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_TC0_ADJ_IACT_allowed(ty);}
};

class TC0_ADJ_TSETAttrib: public Tango::SpectrumAttr
{
public:
	TC0_ADJ_TSETAttrib():SpectrumAttr("TC0_ADJ_TSET", Tango::DEV_LONG, Tango::READ_WRITE, 6) {};
	~TC0_ADJ_TSETAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_TC0_ADJ_TSET(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_TC0_ADJ_TSET(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_TC0_ADJ_TSET_allowed(ty);}
};

class TC0_ADJ_ISETAttrib: public Tango::SpectrumAttr
{
public:
	TC0_ADJ_ISETAttrib():SpectrumAttr("TC0_ADJ_ISET", Tango::DEV_LONG, Tango::READ_WRITE, 6) {};
	~TC0_ADJ_ISETAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_TC0_ADJ_ISET(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_TC0_ADJ_ISET(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_TC0_ADJ_ISET_allowed(ty);}
};

class TCORRAttrib: public Tango::Attr
{
public:
	TCORRAttrib():Attr("TCORR", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~TCORRAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_TCORR(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_TCORR(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_TCORR_allowed(ty);}
};

class MODULE_TACTAttrib: public Tango::Attr
{
public:
	MODULE_TACTAttrib():Attr("MODULE_TACT", Tango::DEV_LONG, Tango::READ) {};
	~MODULE_TACTAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_MODULE_TACT(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_MODULE_TACT_allowed(ty);}
};

class DIODE_TACTAttrib: public Tango::Attr
{
public:
	DIODE_TACTAttrib():Attr("DIODE_TACT", Tango::DEV_LONG, Tango::READ) {};
	~DIODE_TACTAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_DIODE_TACT(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_DIODE_TACT_allowed(ty);}
};

class DIODE_TSETAttrib: public Tango::Attr
{
public:
	DIODE_TSETAttrib():Attr("DIODE_TSET", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~DIODE_TSETAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_DIODE_TSET(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_DIODE_TSET(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_DIODE_TSET_allowed(ty);}
};

class PACTAttrib: public Tango::Attr
{
public:
	PACTAttrib():Attr("PACT", Tango::DEV_LONG, Tango::READ) {};
	~PACTAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_PACT(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_PACT_allowed(ty);}
};

class IACTAttrib: public Tango::Attr
{
public:
	IACTAttrib():Attr("IACT", Tango::DEV_LONG, Tango::READ) {};
	~IACTAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_IACT(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_IACT_allowed(ty);}
};

class UptimeAttrib: public Tango::Attr
{
public:
	UptimeAttrib():Attr("Uptime", Tango::DEV_DOUBLE, Tango::READ) {};
	~UptimeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_Uptime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_Uptime_allowed(ty);}
};

class TstampStartAttrib: public Tango::Attr
{
public:
	TstampStartAttrib():Attr("TstampStart", Tango::DEV_DOUBLE, Tango::READ) {};
	~TstampStartAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_TstampStart(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_TstampStart_allowed(ty);}
};

class TstampDiffAttrib: public Tango::Attr
{
public:
	TstampDiffAttrib():Attr("TstampDiff", Tango::DEV_DOUBLE, Tango::READ) {};
	~TstampDiffAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_TstampDiff(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_TstampDiff_allowed(ty);}
};

class RTstampAttrib: public Tango::Attr
{
public:
	RTstampAttrib():Attr("RTstamp", Tango::DEV_DOUBLE, Tango::READ) {};
	~RTstampAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_RTstamp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_RTstamp_allowed(ty);}
};

class TstampAttrib: public Tango::Attr
{
public:
	TstampAttrib():Attr("Tstamp", Tango::DEV_DOUBLE, Tango::READ) {};
	~TstampAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_Tstamp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_Tstamp_allowed(ty);}
};

class Amplifier_StateAttrib: public Tango::Attr
{
public:
	Amplifier_StateAttrib():Attr("Amplifier_State", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Amplifier_StateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_Amplifier_State(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_Amplifier_State(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_Amplifier_State_allowed(ty);}
};

class ISETAttrib: public Tango::Attr
{
public:
	ISETAttrib():Attr("ISET", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~ISETAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MenloLFC *>(dev))->read_ISET(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MenloLFC *>(dev))->write_ISET(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MenloLFC *>(dev))->is_ISET_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class SaveConfigClass : public Tango::Command
{
public:
	SaveConfigClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SaveConfigClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SaveConfigClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MenloLFC *>(dev))->is_SaveConfig_allowed(any);}
};

class EnterServiceCodeClass : public Tango::Command
{
public:
	EnterServiceCodeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	EnterServiceCodeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~EnterServiceCodeClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MenloLFC *>(dev))->is_EnterServiceCode_allowed(any);}
};

class DeviceSerialCmd : public Tango::Command
{
public:
	DeviceSerialCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DeviceSerialCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DeviceSerialCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MenloLFC *>(dev))->is_DeviceSerial_allowed(any);}
};



class DeviceFWverCmd : public Tango::Command
{
public:
	DeviceFWverCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DeviceFWverCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DeviceFWverCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MenloLFC *>(dev))->is_DeviceFWver_allowed(any);}
};

class DisplayFWverCmd : public Tango::Command
{
public:
	DisplayFWverCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DisplayFWverCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DisplayFWverCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MenloLFC *>(dev))->is_DisplayFWver_allowed(any);}
};


class DeviceHWverCmd : public Tango::Command
{
public:
	DeviceHWverCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DeviceHWverCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DeviceHWverCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MenloLFC *>(dev))->is_DeviceHWver_allowed(any);}
};



class DeviceIDCmd : public Tango::Command
{
public:
	DeviceIDCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DeviceIDCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DeviceIDCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MenloLFC *>(dev))->is_DeviceID_allowed(any);}
};



class DeviceAddressCmd : public Tango::Command
{
public:
	DeviceAddressCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DeviceAddressCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DeviceAddressCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MenloLFC *>(dev))->is_DeviceAddress_allowed(any);}
};



//
// The MenloLFCClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	MenloLFCClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static MenloLFCClass *init(const char *);
	static MenloLFCClass *instance();
	~MenloLFCClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	MenloLFCClass(string &);
	static MenloLFCClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace MenloLFC_ns

#endif // _MENLOLFCCLASS_H
