//
// file :         readthread.h
//
// description :  reading thread
//
// project :      TANGO Device Server
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//


#ifndef READTHREAD_H
#define READTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <MenloLFC.h>
#include "scheduler.h"

class readthread : public omni_thread, public Tango::LogAdapter 
{	
	private:
		MenloLFC_ns::MenloLFC *mydevice;
		//scheduler<string> *readSched;
		scheduler<string> readSched;
		omni_mutex *sched_mutex;
		void abort_sleep(double time); 
				
	public:
		
		readthread(MenloLFC_ns::MenloLFC *s);
		~readthread();
		void force_scheduler(string id);
		void update_scheduler();
					
	protected:
		void run(void *);
		
};	/* end class readthread() */



#endif

/* EOF */
